/*
 * Copyright 1993 Torstein Hansen
 */


#ifndef _Fibw_h
#define _Fibw_h

/*
 * Public include file for Fibw - The Fabulously Impressive Backgammon 
 *                                board Widget 
 */


#define XtNtoggleCallback "toggleCallback"
#define XtNpixmapWidth	  "pixmapWidth"
#define XtNpixmapHeight	  "pixmapHeight"
#define XtNtable	  "table"
#define XtNbase		  "base"
#define XtNframe	  "frame"
#define XtNwpoint	  "wpoint"
#define XtNbpoint	  "bpoint"
#define XtNwpiece	  "wpiece"
#define XtNbpiece	  "bpiece"
#define XtNdblcube	  "dblcube"
#define XtNdbltext	  "dbltext"
#define XtNnumbers	  "numbers"
#define XtNonFrame	  "onframe"
#define XtNdebug	  "debug"
#define XtNlogstyle	  "logstyle"

#define XtCToggleCallback "ToggleCallback"
#define XtCPixmapWidth	  "PixmapWidth"
#define XtCPixmapHeight	  "PixmapHeight"
#define XtCTable	  "Table"
#define XtCBase		  "Base"
#define XtCFrame	  "Frame"
#define XtCWpoint	  "Wpoint"
#define XtCBpoint	  "Bpoint"
#define XtCWpiece	  "Wpiece"
#define XtCBpiece	  "Bpiece"
#define XtCDblcube	  "Dblcube"
#define XtCDbltext	  "Dbltext"
#define XtCNumbers	  "Numbers"
#define XtCOnFrame	  "OnFrame"
#define XtCDebug	  "Debug"
#define XtCLogstyle	  "Logstyle"

#define fi_board	0
#define fi_move		1
#define fi_redisplay	2
#define fi_newboard	3

/* 
 * Fields for the Fibw widget fibs_rec record 
 * most fields are the same as in the rawboard description 
*/

typedef struct {
    char playername[80];   /* Make room for loooong names,      */
    char opponentname[80]; /* you never know who may turn up :) */
    int match_length;
    int player_got;
    int opponent_got;
    int board[28];    /* negative values - white pieces, 
			 positive values - black pieces.  
                         0 and 25 represents bar. 
			 26 is home for same player as 0 is bar
			 27 is home for same player as 25 is bar*/
    int turn;
    int playerdice[2];  
    int opponentdice[2];
    int cube;
    int playerMayDouble;
    int opponentMayDouble;
    int was_doubled[2];
    int color;
    int direction;
    int home;
    int bar;
    int playerOnHome;
    int opponentOnHome;
    int playerOnBar;
    int opponentOnBar;
    int can_move;
    int forced_move;
    int did_crawford;
    int redoubles;
    
} FIBS_Rec;


typedef struct {
	int	used;		/* Flag if used - store roll number here */
	int	hit;		/* Flag if hit */
	int	value;		/* Roll */
	int	from;
	int	to;
	char	move[8];	/* String for the move */
} Dice;


/* Class record constants */

extern WidgetClass fibwWidgetClass;

typedef struct _FibwClassRec *FibwWidgetClass;
typedef struct _FibwRec      *FibwWidget;

/* external functions */
#ifdef _NO_PROTO
extern void FibwRoll();
extern void FibwDiceRolled(); 
extern void FibwSetInfo();
extern void FibwJoin();
extern void debugAvail();
extern void debugFirst();
extern void debugBoard();
#else
extern void FibwRoll(FibwWidget);
extern void FibwDiceRolled(FibwWidget, char *, char *, int, int); 
extern void FibwSetInfo(FibwWidget, char *, int);
extern void FibwJoin(FibwWidget, char *);
extern void debugAvail(FibwWidget);
extern void debugFirst(FibwWidget, int);
extern void debugBoard(char *);
#endif


#endif /* _Fibw_h */
/* DON'T ADD STUFF AFTER THIS #endif 



   ...and I mean it!
*/
















































/* Don't you believe me???    */
